package sdis_2015;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Active implements Runnable {

	int id_sensor;
	Thread timeout;

	public Active(int sensor) {
		this.id_sensor = sensor;
	}

	public void run() {
		try {
			Thread.sleep(0, 1); // 1 nanosecond.
		} catch (InterruptedException ex) {
			Thread.currentThread().interrupt();
		}
		while (!SDIS_2015.end) {

			try {
				Thread.sleep(0, 1); // 1000 milliseconds is one second.
			} catch (InterruptedException ex) {
				Thread.currentThread().interrupt();
			}

			if (SDIS_2015.start && !SDIS_2015.sensores[id_sensor].wait
					&& SDIS_2015.sensores[id_sensor].ciclo) {

				try {

					Thread.sleep((long) (Math.random() * 10)); // gerar tempo
																// aleatório
					if (SDIS_2015.sensores[id_sensor].wait == false) {
						SDIS_2015.sensores[id_sensor].wait = true;
						int ip_remote = sdis_2015.SDIS_2015.sensores[id_sensor]
								.GetNeighbor();
						if (SDIS_2015.sensores[this.id_sensor].DEBUG)
							System.out.println(id_sensor + " sending to "
									+ ip_remote);
						if (ip_remote != -1) {
							SDIS_2015.sensores[id_sensor]
									.send_multicast(
											"MATCH",
											ip_remote,
											SDIS_2015.sensores[id_sensor].stateP,
											false);

							timeout = new Thread(new Timeout(id_sensor));

							timeout.start();
							SDIS_2015.sensores[id_sensor].cnt = 0;
							SDIS_2015.sensores[id_sensor].received = false;
						} else
							SDIS_2015.sensores[id_sensor].wait = false;

					}
				} catch (InterruptedException | IOException ex) {
					Logger.getLogger(Active.class.getName()).log(Level.SEVERE,
							null, ex);
				}
			}
		}
		if (SDIS_2015.sensores[this.id_sensor].DEBUG)
			System.out.println("morri Active" + id_sensor);
	}
}
